import { createVNode as _createVNode } from "vue";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { defineComponent, onMounted, ref, watch } from 'vue';
import Pickr from '@simonwep/pickr';
export default defineComponent({
  name: 'ColorPickr',
  props: {
    value: String,
    theme: {
      type: String,
      default: 'classic'
    },
    disabled: Boolean,
    opacity: {
      type: Boolean,
      default: false
    }
  },
  emits: ['update:value'],

  setup(props, _ref) {
    var attrs = _ref.attrs,
        emit = _ref.emit,
        slots = _ref.slots;
    var pickr;
    var container = ref(null);
    onMounted(() => {
      if (container.value) {
        pickr = Pickr.create(_objectSpread(_objectSpread({
          el: container.value,
          appClass: "".concat(attrs.class),
          theme: props.theme,
          // or 'monolith', or 'nano'
          disabled: props.disabled,
          swatches: ['#D0021B', '#F5A623', '#F8E71C', '#8B572A', '#7ED321', '#417505', '#BD10E0', '#9013FE', '#4A90E2', '#50E3C2', '#B8E986', '#000000', '#4A4A4A', '#9B9B9B', '#FFFFFF'],
          components: {
            // Main components
            preview: true,
            opacity: props.opacity,
            hue: true,
            // Input / output Options
            interaction: {
              hex: true,
              rgba: true,
              hsla: true,
              hsva: true,
              cmyk: true,
              input: true
            }
          },
          showAlways: false
        }, attrs), {}, {
          default: props.value,
          useAsButton: true
        }));
        pickr.on('change', (color, event) => {
          pickr.applyColor(true);
          emit('update:value', color.toHEXA().toString());
        });
      }
    });
    watch(() => props.value, () => {
      if (pickr && props.value !== pickr.getColor().toHEXA().toString()) {
        pickr.setColor(props.value || null);
      }
    });
    watch(() => props.disabled, () => {
      if (pickr) {
        if (props.disabled) {
          pickr.disable();
        } else {
          pickr.enable();
        }
      }
    });
    return () => {
      var _slots$default;

      return _createVNode("div", {
        "ref": container,
        "class": ['pickr', attrs.class]
      }, [((_slots$default = slots.default) === null || _slots$default === void 0 ? void 0 : _slots$default.call(slots, props.value)) || _createVNode("button", {
        "type": "button",
        "class": "pcr-button",
        "role": "button",
        "aria-label": "toggle color picker dialog",
        "style": props.value ? {
          '--pcr-color': props.value
        } : undefined
      }, null)]);
    };
  }

});